Description

Hi.I’'m using redmine 2.6.2. | have created a custom field wich type is float. | want to use comma as decimal separator.
But when i set locale to , pt or pt-BR, for instance, if the user inputs a

float like '95,70' or '500,25' in a form input, numerical

validation will yield an 'invalid_number' error, even though this is a

valid format in Brazil.

Only works if i use dot as decimal separator... but it is not the right way to do it.

Is that a newer version of redmine that fix it ?

How we that uses comma as decimal separator deals with with number formats in redmine?

Thanks!

Related issues:

Related to Redmine - Feature #21677: Support localized decimal separator for ... Closed

Related to Redmine - Feature #36183: Dynamic decimal separator, according to ... Closed

Related to Redmine - Defect #6182: Localized decimal numbers Closed 2010-08-20
Related to Redmine - Feature #39997: Add an option to render values of Intege... Closed

Related to Redmine - Feature #25012: Allow both "." and ', decimal symbols f... Closed

Related to Redmine - Defect #42233: Float custom values with ', as decimal s... Closed

Associated revisions

Revision 22592 - 2024-01-04 07:55 - Go MAEDA

Support localized decimal separators for float values (#22024).

Patch by Liane Hampe (@liane_hampe).

Revision 22594 - 2024-01-04 08:04 - Go MAEDA

Support localized decimal separators for float values in PDF export (#22024).

Patch by Go MAEDA (@maeda).

History

#1 - 2016-02-13 03:40 - Toshi MARUYAMA

- Related to Feature #21677: Support localized decimal separator for hours in the web Ul added

#2 - 2016-02-13 03:43 - Toshi MARUYAMA

- Subject changed from decimal separator in float custom filed doesn’t work to Validation error on float custom filed in case of i18n decimal separator

#3 - 2016-02-15 14:22 - Rafael Neves

thanks!

#4 - 2023-09-05 18:28 - Liane Hampe

- File support-localized-decimal-separator.patch added
Hi,

I'd like to set the focus on the missing support for localized decimal separators and delimiters in custom fields of format 'float' again. That is, inserting
for example

# Separator problem

42,5 ——> won't currently be valid.
The user needs to type in

42.5 instead.

# Delimiter problem
10000, 99 should be rendered as 10.000,00 instead.

There are several issues (#25012, #36183) addressing this problem and a lot of countries using the decimal comma instead of dot as you can see
here: https://en.wikipedia.org/wiki/Decimal_separator.

| provided a patch solving this issue. It also includes tests.

Probably, there are many Redmine users which would appreciate this improvement.
Would be nice seeing it in a future release! :)

What are your thoughts?

#5 - 2023-09-05 19:40 - Rafael Neves

Hi,

It would be great see that patch included in future release.

Nice work !

Best regards

#6 - 2023-09-07 09:00 - Liane Hampe

Go MAEDA: Please note the patch (https:/www.redmine.org/issues/220244#note-4) for supporting localized decimal separators and delimiters in float
custom field values.

| would love to see it in a future release. :)

#7 - 2023-09-18 07:30-C S

+1
Relation: #36183

#8 - 2023-12-30 10:32 - Go MAEDA
- File 22024-v2.patch added

- Target version set to Candidate for next major release

Liane Hampe wrote in #note-6:

Go MAEDA: Please note the patch (hitps:/www.redmine.org/issues/22024#note-4) for supporting localized decimal separators and delimiters in
float custom field values.

Thank you for posting the patch. | think the patch makes it more user-friendly for international users.

The patch by Liane Hampe also adds the ability to display thousand delimiters. However, | think displaying thousand delimiters should be out of the
scope of this patch. This is because not all users may agree with always displaying the thousand delimiter. Additionally, at this time, entering a value
with a thousand delimiter into a custom field results in a validation error. In my opinion, the feature to display thousand delimiters should be discussed
in another issue.

| have updated the patch for the current trunk and removed the feature to display thousand delimiters.

#9 - 2023-12-30 19:43 - Rafael Neves

| appreciate and agree with that. In fact, the issue is on decimal separator, despite the plus done related to thousand issue.

#10 - 2024-01-01 07:48 - Go MAEDA

- Related to Feature #36183: Dynamic decimal separator, according to country setting added
#11 - 2024-01-01 09:07 - Go MAEDA
- Related to Defect #6182: Localized decimal numbers added

#12 - 2024-01-01 10:55 - Mischa The Evil
Go MAEDA wrote in #note-8:

[...] at this time, entering a value with a thousand delimiter into a custom field results in a validation error. In my opinion, the feature to display
thousand delimiters should be discussed in another issue.

| have updated the patch for the current trunk and removed the feature to display thousand delimiters.

| agree with that. A separate, additional feature providing a custom field option (using field_attributes?) to display thousand delimiters for selected
Float (but also Integer) custom fields could be nice to have in some cases when dealing with larger values, but that's not related to the decimal
separator issue indeed (nor is it fully covered by the solution in the provided patch). I've opened issue #39997 for that.

However, | think that Redmine doesn't need to provide support for entering values with thousands delimiters into a custom field. It feels like overkill to
me.

Regarding the v2-patch: it looks good to me, but the proposed method test_float_field_should_format_with_various_locale_separator_and_delimiter
doesn't explicitly test anything delimiter related anymore, so maybe it's better to drop the postfix from its name.

About the scheduling: given the potential impact of the proposed changes downstream, | agree with bringing this in a major release, but why not in
6.0.0?7 The current state of this patch seems pretty complete to me.

OTOH, it might be desirable for downstream compatibility maintenance to bring this change together in one go with the contextually-related, currently
yet incomplete issues #21677 and #35726 (with #31637). If it is deemed a desired feature, then also #39997, would ideally be brought along with
those at the same time too.

#13 - 2024-01-01 11:31 - Go MAEDA
- File 22024-v3.patch added

- Target version changed from Candidate for next major release to 6.0.0

Updated the patch again.
Estimated hours, spent time, and PDF export now also support internationalized decimal separator.

Mischa The Evil wrote in #note-12:

Regarding the v2-patch: it looks good to me, but the proposed method
test_float_field_should_format_with_various_locale_separator_and_delimiter doesn't explicitly test anything delimiter related anymore, so maybe
it's better to drop the postfix from its name.

Fixed. Thank you.

Setting the target version to 6.0.0.

#14 - 2024-01-03 14:50 - Holger Just

- Related to Feature #39997: Add an option to render values of Integer- and Float-format custom fields with thousands delimiters added

#15 - 2024-01-04 03:44 - Go MAEDA
- Related to Feature #25012: Allow both "." and '," decimal symbols for input of float custom fields added

#16 - 2024-01-04 03:55 - Go MAEDA
- Tracker changed from Defect to Feature

- Subject changed from Validation error on float custom filed in case of i18n decimal separator to Support locale-dependent decimal separators for
float values

- Affected version deleted (2.6.2)

#17 - 2024-01-04 07:50 - Go MAEDA

- Subject changed from Support locale-dependent decimal separators for float values to Support localized decimal separators for float values

#18 - 2024-01-04 08:07 - Go MAEDA
- Status changed from New to Closed
- Assignee set to Go MAEDA

- Resolution set to Fixed

2025-07-12 3/4


https://www.redmine.org/issues/39997
https://www.redmine.org/issues/21677
https://www.redmine.org/issues/35726
https://www.redmine.org/issues/31637
https://www.redmine.org/issues/39997

Committed Liane Hampe 's patch with slight changes in r22592. Also, | added support for PDF export in r22594.
Thank you for your contribution.

#19 - 2024-06-11 12:23 - Mathias Walter

Can this patch included in 5.1.x, too? It does not require any new dependencies. Hence, it should be easy to apply it.

#20 - 2025-02-07 03:59 - Go MAEDA

- Related to Defect #42233: Float custom values with ', as decimal separator are not converted to "' and cause SQL errors when sorting or summing
added

Files

support-localized-decimal-separator.patch 3.87 KB 2023-09-05 Liane Hampe
22024-v2.patch 3.83 KB 2023-12-30 Go MAEDA
22024-v3.patch 7.03 KB 2024-01-01 Go MAEDA
